/*
context browser updater
part of conTEXT Amarok plugin
*/
function generateTextBox(textcontents,textfilenames,originaltextfilenames,height,expand) {

	// initialize globals
	filetexts = textcontents.replace(/<br>/g,"\n").split("<conTEXT:mark>");
	filenames = textfilenames.split("<conTEXT:mark>");
	originalfilenames = originaltextfilenames.split("<conTEXT:mark>");
	conTEXTheight = parseInt(height);
	conTEXTheight_tmp = conTEXTheight;
	boxpadding = "%s";
	expanded = (expand == "True") ? true : false;
	lineheight = 13; //FIXME: must know the real fontsize :/
	searchSite = "";

	var row = document.createElement('tr');
	row.setAttribute('class','box-row');
	
	var cell = document.createElement('td');
	
	var div = document.createElement('div');
	div.setAttribute('id','conTEXT_content');

	var pre = document.createElement('div');
	div.appendChild(pre);
	
	var iframe = document.createElement('iframe');
	//iframe.setAttribute('id','conTEXT_frame');
	//iframe.setAttribute('name','conTEXT_frame');
	iframe.setAttribute('width','100%%');
	iframe.setAttribute('height',conTEXTheight);
	iframe.setAttribute('scrolling','no');
	iframe.setAttribute('border','0');
	iframe.setAttribute('style','border:0px; margin-top:-2px;');
	div.appendChild(iframe);
	
	cell.appendChild(div);
	row.appendChild(cell);
	return row;
}

function fileNumber() {
	var r = '';
	if(filenames.length > 1)
		r = '(' + String(fileindex+1) + '/' + filenames.length + ') ';
	return r;
}

function prettyFilename(f) {
	filename_max = (filenames.length > 1 || resizing) ? 30 : 35;
	var r = baseFilename(f);
	// cut off extension (for reviews)
	if( /.*\..*\./g.test(r) )
		r = r.substr(0, r.lastIndexOf("."));
	r = (r.length > filename_max) ? r.substr(0,filename_max) + '...' : r;
	return r;
}

function baseFilename(f) {
	var r = f.substr(f.lastIndexOf('/')+1);
	r = r.substr(0,r.length-5) // cut off the extra ".html"
	return r;
}

// count lines UP TO conTEXTheight/lineheight if not untilEnd
function linecount(str,untilEnd) {
	var count=0;
	for(var i=0; i<str.length; i++) {
		if(str.charAt(i) == '\n') {
			if(++count >= conTEXTheight/lineheight && !untilEnd)
				break;
		}
	}
	return count;
}

function showNextFile() {
	fileindex++;
	showBlock('T_CT'); //it was collapsed due to the onclick event, so undo it
	
	var filechanged = false;
	if(fileindex != curindex) {
		filechanged = true;
		autoshrink = true; //reset
	}
	
	if(fileindex == filenames.length)
		fileindex = 0;
	
	var fname = filenames[fileindex];
	var ftext = filetexts[fileindex];
	document.getElementById('conTEXT_filename').firstChild.data =
		fileNumber() + prettyFilename(fname);
	document.getElementById('conTEXT_filename').title =
		baseFilename(fname).length > filename_max ? baseFilename(fname) : "";

	var node = document.getElementById('conTEXT_content');
	node.lastChild.height = conTEXTheight;

	if(ftext && ftext.length > 0) {
		// plaintext file
		isNFO = false;
		if(fname.substr(fname.length-4-5,4) == ".nfo" || fname.substr(fname.length-4-5,4) == ".NFO")
			isNFO = true;

		if(expanded) {
			// update the (former) <pre>
			textnode = "";
			while(node.firstChild.hasChildNodes())
				node.firstChild.removeChild(node.firstChild.firstChild);
			for(var i=0; i<ftext.length; i++) {
				if(isNFO && ftext.charAt(i) == ' ') {
					textnode += '\u00a0'; //&nbsp;
				} else {
					textnode += ftext.charAt(i);
				}
				if(ftext.charAt(i) == '\n') {
					node.firstChild.appendChild(document.createTextNode(textnode));
					node.firstChild.appendChild(document.createElement('br'));
					textnode = "";
				}
			}
			node.firstChild.appendChild(document.createTextNode(textnode));

			if(isNFO) {
				node.firstChild.style.setAttribute("font-family","Lucida ConsoleP","false");
				node.firstChild.style.setAttribute("line-height","1em","false");
			} else {
				node.firstChild.style.removeAttribute("font-family","false");
				node.firstChild.style.removeAttribute("line-height","false");
			}
			node.firstChild.style.display = 'block';
			node.lastChild.style.display = 'none';

		} else {
			if(filechanged || node.lastChild.style.display == 'none') {
				// update and auto-shrink iframe
				node.firstChild.style.display = 'none';
				node.lastChild.style.display = 'block';
				node.lastChild.src = fname;
				if(isNFO) lineheight = 9;
				else lineheight = 13;
// 				var newheight = lineheight + lineheight * linecount(ftext) + 1;
// 				if(newheight < conTEXTheight && autoshrink)
// 					node.lastChild.height = newheight;
			}
		}
	} else {
		if(filechanged) {
			// normal html mode, update iframe
			node.firstChild.style.display = 'none';
			node.lastChild.style.display = 'block';
			node.lastChild.src = fname;
		}
		if(expanded)
			node.lastChild.height = window.innerHeight-25;
	}
	curindex = fileindex;
}
			
function showPrevFile() {
	if(fileindex == 0) fileindex = filenames.length-2;
	else fileindex -= 2;
	showNextFile();
}

function showFile(index) {
	fileindex = parseInt(index);
	if(fileindex == 0 || fileindex >= filenames.length)
		fileindex = -1;
	else
		fileindex--;
	curindex = fileindex;
	showNextFile();
}

function showFileWithName(name) {
	for(i=0; i<filenames.length; i++) {
		if(baseFilename(filenames[i]) == name) {
			showFile(i);
			return;
		}
	}
	showFile(0);
}

function refreshBox(newheight,expand) {
	conTEXTheight = parseInt(newheight);
	expanded = (expand == "True" || expand == true) ? true : false;
	document.getElementById('conTEXT_maximize').firstChild.data = expanded ? ' -- ' : ' + ';
	document.getElementById('conTEXT_maximize').title = expanded ? 'Restore' : 'Maximize';
	setTmpHeight();
	fileindex--;
	showNextFile();
}

function resizeBox() {
	var step = event.y - resize_curpos;
	resize_curpos = event.y;
	
	if (resizing && conTEXTheight + step >= 0) {
		autoshrink = false;
		conTEXTheight_tmp += step;
		refreshBox(conTEXTheight_tmp, false);
		
		document.getElementById('conTEXT_filename').firstChild.data =
			' [' + conTEXTheight_tmp + '] ' + prettyFilename(filenames[fileindex]);
		}
}

function setTmpHeight() {
	if(expanded)
		if(filetexts[fileindex].length > 0)
			conTEXTheight_tmp = lineheight + lineheight * linecount(filetexts[fileindex],true) + 1;
		else
			conTEXTheight_tmp = window.innerHeight-25;
	else
		conTEXTheight_tmp = conTEXTheight;
}

function resizeBoxStart() {
	resizing = true;
	resize_curpos = event.y;
	setTmpHeight();
}

function resizeBoxStop() {
	resizing = false;
	document.getElementById('conTEXT_filename').firstChild.data =
		fileNumber() + prettyFilename(filenames[fileindex]);
}

function moveBox() {
	if (moving) {
		var box = document.getElementById('conTEXT_box');

		if (event.y > move_curpos+60) {
			var clone = box.cloneNode(true);
			box.parentNode.insertBefore(clone, box.nextSibling.nextSibling);
			box.parentNode.removeChild(box);
			move_curpos = event.y;
			clone.setAttribute('id','conTEXT_box');
			justmoved = true;
		} else if(event.y < move_curpos-60 && box.previousSibling != null) {
			var clone = box.cloneNode(true);
			box.parentNode.insertBefore(clone, box.previousSibling);
			box.parentNode.removeChild(box);
			move_curpos = event.y;
			clone.setAttribute('id','conTEXT_box');
			justmoved = true;
		}
	}
}

function moveBoxStart() {
	moving = true;
	justmoved = false;
	move_curpos = event.y;
	resizeBoxStart();
	resizeBoxStop();
}

function moveBoxStop() {
	moving = false;
	justmoved = false;
}

// this (kind of) monitors toggleBlock and hides the resizer accordingly..
function monitorVisibility() {
	if(document.getElementById('conTEXT_resizer') != null) {
		if (document.getElementById('T_CT').style.display == 'none')
			document.getElementById('conTEXT_resizer').style.display='none';
		else 
			document.getElementById('conTEXT_resizer').style.display='block';
	}
	setTimeout("monitorVisibility()",500);
}

function showBlock(id) {
	if(document.getElementById(id).style.display=="none")
		toggleBlock(id);
}
function hideBlock(id) {
	document.getElementById(id).style.display="none";
}

function getConfig() {
	var sibling = "";
	var ref = document.getElementById('conTEXT_box');
	var i = ref;
	while(i = i.nextSibling)
		if(i.nodeName == "div") {
			sibling = i.id;
			break;
		}
	var shaded = (document.getElementById('T_CT').style.display == 'none') ? true : false;

	return	conTEXTheight +
			',' +
 			baseFilename(filenames[curindex]) +
			',' +
			sibling +
			',' +
			shaded +
			',' +
			expanded +
			',' +
			conTEXTscrollpos +

			'';
}

function undoInjection() {
	var ref = document.getElementById('conTEXT_box');
	if(ref) ref.parentNode.removeChild(ref);
	var ref = document.getElementById('conTEXT_search');
	if(ref) ref.parentNode.removeChild(ref);
	var ref = document.getElementById('conTEXT_info');
	if(ref) ref.parentNode.removeChild(ref);
}

try {
	var testCurrentTab = document.getElementById('current_box-largecover-td');
	if (testCurrentTab != null) {
	
		var testAlreadyAdded = document.getElementById('conTEXT_box');
		if (testAlreadyAdded != null) {
			testAlreadyAdded.parentNode.removeChild(testAlreadyAdded);
		}
		
		var conTEXTbox = document.createElement('div');
		conTEXTbox.setAttribute('id','conTEXT_box');
		conTEXTbox.setAttribute('class','box');

		var conTEXTboxHeader = document.createElement('div');
		conTEXTboxHeader.setAttribute('id','conTEXT_box-header');
		conTEXTboxHeader.setAttribute('onmouseup','if(!justmoved)toggleBlock("T_CT")');
		conTEXTboxHeader.setAttribute('onmousedown','moveBoxStart()');
		conTEXTboxHeader.setAttribute('style','cursor: move;');
		conTEXTboxHeader.setAttribute('class','box-header');

		var conTEXTboxHeaderTitle = document.createElement('span');
		conTEXTboxHeaderTitle.setAttribute('class','box-header-title');
		conTEXTboxHeaderTitle.setAttribute('style','cursor:pointer;');
		//conTEXTboxHeaderTitle.appendChild(document.createTextNode('conTEXT: '));
			
		var conTEXTboxHeaderPrev = document.createElement('a');
		//conTEXTboxHeaderPrev.setAttribute('class','box-header-nav');
		conTEXTboxHeaderPrev.setAttribute('id','conTEXT_prevfile');
		conTEXTboxHeaderPrev.setAttribute('onclick','showPrevFile()');
		conTEXTboxHeaderPrev.setAttribute('style','cursor:pointer; display:inline;');
		conTEXTboxHeaderPrev.setAttribute('title','Switch to previous file');
		conTEXTboxHeaderPrev.appendChild(document.createTextNode('<- '));
		conTEXTboxHeaderTitle.appendChild(conTEXTboxHeaderPrev);

		var conTEXTboxHeaderFilename = document.createElement('div');
		conTEXTboxHeaderFilename.setAttribute('id','conTEXT_filename');
		conTEXTboxHeaderFilename.setAttribute('style','cursor:pointer; display:inline;');
		conTEXTboxHeaderFilename.appendChild(document.createTextNode(''));
		conTEXTboxHeaderTitle.appendChild(conTEXTboxHeaderFilename);

		var conTEXTboxHeaderNext = document.createElement('a');
		conTEXTboxHeaderNext.setAttribute('id','conTEXT_nextfile');
		conTEXTboxHeaderNext.setAttribute('onclick','showNextFile()');
		conTEXTboxHeaderNext.setAttribute('style','cursor:pointer; display:inline;');
		conTEXTboxHeaderNext.setAttribute('title','Switch to next file');
		conTEXTboxHeaderNext.appendChild(document.createTextNode(' ->'));
		conTEXTboxHeaderTitle.appendChild(conTEXTboxHeaderNext);

		var conTEXTboxHeaderMax = document.createElement('a');
		conTEXTboxHeaderMax.setAttribute('id','conTEXT_maximize');
		conTEXTboxHeaderMax.setAttribute('onclick','refreshBox(conTEXTheight, expanded?false:true)');
		conTEXTboxHeaderMax.setAttribute('style','cursor:pointer; display:inline; float:right; padding-right:3px; letter-spacing:-1px;');
		conTEXTboxHeaderMax.setAttribute('title','Maximize');
		conTEXTboxHeaderMax.appendChild(document.createTextNode(' + '));
		conTEXTboxHeaderTitle.appendChild(conTEXTboxHeaderMax);

		conTEXTboxHeader.appendChild(conTEXTboxHeaderTitle);
					
		var refBoxTable = document.getElementById('current_box-table');
		if(!refBoxTable) refBoxTable = document.getElementById('current_box-body');
		if(!refBoxTable) refBoxTable = document.getElementById('stream-history_box-body');
		if(!refBoxTable) refBoxTable = document.createElement('table');
		var conTEXTboxTable = refBoxTable.cloneNode(true);
		conTEXTboxTable.setAttribute('id','T_CT');
		conTEXTboxTable.setAttribute('class','box-body');

		var conTEXTboxTBody = conTEXTboxTable.firstChild

		while (conTEXTboxTBody.hasChildNodes()) {
			conTEXTboxTBody.removeChild(conTEXTboxTBody.firstChild);
		}
		
		var conTEXTboxActualBox = generateTextBox("%s","%s","%s","%s","%s");
		conTEXTboxTBody.appendChild(conTEXTboxActualBox);
		
		conTEXTbox.appendChild(conTEXTboxHeader);
		conTEXTbox.appendChild(conTEXTboxTable);
		
		paddingoffset = "-" + boxpadding + "px";
		var resizer = document.createElement('div');
		resizer.setAttribute('id','conTEXT_resizer');
		resizer.setAttribute('style','width:100%%; height:2px !important; font-size:1px !important; '+
							 'position:relative; bottom:'+paddingoffset+'; cursor:s-resize;');
		resizer.setAttribute('title','Drag here to resize the box');
		resizer.setAttribute('onmousedown','resizeBoxStart();');

		//a hack to avoid text selection when resizing
		span = document.createElement('span');
		span.setAttribute('style','position:absolute;left:-50px;');
		span.appendChild(document.createTextNode('.'));
		resizer.appendChild(span);

		conTEXTbox.appendChild(resizer);
		
		//must set mouse event handling for whole document
		var refBox = document.getElementById('current_box');
		refBox.parentNode.setAttribute('onmousemove','resizeBox();moveBox()');
		refBox.parentNode.setAttribute('onmouseup','if(resizing)resizeBoxStop();if(moving)moveBoxStop()');
							
		resizing = false;
		autoshrink = true;
			
		// insert the box now
		desiredNextSibling = "%s";
		refBox = document.getElementById(desiredNextSibling);
		if(refBox) {
			// at the last saved position
			refBox.parentNode.insertBefore(conTEXTbox, refBox);
// 			alert('at last position: '+desiredNextSibling);
		}
		else if (desiredNextSibling == '') {
			// means at the end
			refBox = document.getElementById('current_box');
			refBox.parentNode.insertBefore(conTEXTbox, refBox.parentNode.lastChild.nextSibling);
// 			alert('at last position: end');
		}
		else {
			// default 1: after related box
			refBox = document.getElementById('related_box');
			if(refBox) {
				refBox.parentNode.insertBefore(conTEXTbox, refBox.nextSibling);
// 				alert('def1: after related_box');
			} else {
				// default 2: after current box
				refBox = document.getElementById('current_box');
				refBox.parentNode.insertBefore(conTEXTbox,refBox.nextSibling);
// 				alert('def2: after current_box');
			}
		}

		monitorVisibility();
		showFileWithName("%s");
		info(filenames.length);
		conTEXTscrollpos = "%s";
		conTEXTscrollremember = true;

		if("%s"=="True") toggleBlock('T_CT'); //shaded saved state
		if(expanded) {
			document.getElementById('conTEXT_maximize').firstChild.data = expanded ? ' -- ' : ' + ';
			document.getElementById('conTEXT_maximize').title = expanded ? 'Restore' : 'Maximize';
			setTmpHeight();
		}
		if(filenames.length == 1) {
			document.getElementById('conTEXT_nextfile').style.display = "none";
			document.getElementById('conTEXT_prevfile').style.display = "none";
		}
		searchSites = "%s";

	}
} catch (e) {
	alert('An error occurred while updating the context browser. Please report this to the conTEXT developers:\n\n' + e);
}
