/*
conTEXTmenu.js: status icon and search menu
part of conTEXT amaroK plugin
*/
var basepath = '%s';
var frame = 0;
var numfiles = 0;
var anim;
var searchSite = "";
var clickedURL = "";
var file2edit = "";
var file2trash = "";
var searchnow = "";
var origImage = ""; var origImageWidth = 0; var origImageHeight = 0;

function info(num) {
	var path;
	switch(num) {
		case -1:
			clearTimeout(anim);
			msg = "conTEXT: searching...";
			path = basepath + "/search0.png";
			anim = setTimeout("animateIcon()",500);
			removeInfo();
			break;
		case 0:
			clearTimeout(anim);
			msg = "conTEXT: no files";
			path = basepath + "/icon0.png";
			numfiles = num;
			removeInfo();
			break;
		default:
			clearTimeout(anim);
			msg = "conTEXT: showing " + num + (num==1 ? " file" : " files");
			path = basepath + "/icon1.png";
			numfiles = num;
			removeInfo();
			break;
	} 
	inf = document.createElement('div');
	inf.setAttribute('id', 'conTEXT_info');
	inf.setAttribute('style', 'position:fixed;bottom:-7px;right:-1px;z-index:100;');
	inf.setAttribute('title', msg);
	inf.setAttribute('onmouseover', 'showSearchMenu()');
	inf.setAttribute('onclick', 'toggleSearchMenu()');
	 img = document.createElement('img');
	 img.setAttribute('id', 'conTEXT_icon');
	 img.setAttribute('src', path);
	inf.appendChild(img);
	
	ref = document.getElementById('current_box');
	ref.insertBefore(inf, ref.lastChild);
	
	addEyeCandy();
}
function addEyeCandy() {
	document.getElementById('current_box-largecover-image').onmouseover = function() {
		if (largecover.indexOf('nocover')!=-1) return;
		var image = document.getElementById('current_box-largecover-image');
		var a = document.getElementById('current_box-largecover-a');
		var td = document.getElementById('current_box-largecover-td');
		if(image.src!=largecover) {origImage = image.src; origImageWidth = image.width; origImageHeight = image.height; }
		image.src = largecover;
		image.width = window.innerWidth-2;
		image.height = window.innerWidth-2;
		a.setAttribute('style', 'position:fixed;top:-4px;left:-4px;');
		td.setAttribute('style','height:'+(window.innerWidth-50)+'px');
		var f = document.frames.length;
		if (f > 0) {
			document.frames[f-1].location.reload();
			document.frames[f-1].scrollTo(0,conTEXTscrollpos); //not working!
		}
	}
	document.getElementById('current_box-largecover-image').onmouseout = function() {
		if (largecover.indexOf('nocover')!=-1 || !origImage) return;
		var image = document.getElementById('current_box-largecover-image');
		var a = document.getElementById('current_box-largecover-a');
		var td = document.getElementById('current_box-largecover-td');
		a.setAttribute('style', 'position:static;');
		image.src = origImage;
		image.width = origImageWidth != image.width ? origImageWidth : 140; 
		image.height = origImageHeight != image.height ? origImageHeight : 140;
		td.setAttribute('style','height:auto;');
		//image.width = 130;
		//image.height = 130;
	}
}
function animateIcon() {
	document.getElementById('conTEXT_icon').src = basepath + "/search"+(frame%%4)+".png";
	frame += 1;
	anim = setTimeout("animateIcon()",500);
}
function showSearchMenu() {
	if(document.getElementById('conTEXT_search')) return;
	
	popup = document.createElement('div');
	popup.setAttribute('id', 'conTEXT_search');
	popup.setAttribute('onmouseover', 'showSearchMenu()');
	popup.setAttribute('onmouseout', 'removeSearchMenu()');
	
	search = document.createElement('div');
	search.setAttribute('style', 'position:fixed;bottom:9px;right:0px;z-index:100;background:white;color:black;border:1px outset black;font-weight:bold;text-align:left;white-space:nowrap;');
	 c = document.createElement('div');
	 c.setAttribute('style', 'float:right;font-weight:bold;font-style:italic;cursor:pointer;');
	 c.setAttribute('onmouseover', 'showSearchMenu()');
	 c.setAttribute('onclick', 'toggleAll()');
	 c.setAttribute('title', 'Auto-search all sites');
	 c.appendChild(document.createTextNode("Auto"));
	search.appendChild(c);
	search.appendChild(document.createTextNode("Search reviews"));
		
	sites = searchSites.split(" ");
	for(i=0; i<sites.length; i++) {
		site = sites[i].split(":");
		if(mustHide(site[0]))
			continue;
		s = document.createElement('div');
		s.setAttribute('id', 'conTEXT_search_'+site[0]);
		s.setAttribute('style', 'border-top:1px dotted gray;font-weight:normal;padding-right:20px;cursor:pointer;');
		s.setAttribute('onmouseover', 'showSearchMenu()');
		 c = document.createElement('div');
		 c.setAttribute('id', 'conTEXT_autosearch_'+site[0]);
		 c.setAttribute('style', 'float:right;margin-right:-20px;');
		 c.setAttribute('onclick', 'toggleAutoSearch("'+site[0]+'");');
		 c.setAttribute('title', 'Auto-search '+site[0]);
		  img = document.createElement('img');
		  if(site[1]=="True")
			img.setAttribute('src', basepath+'/check1.png');
		  else
			img.setAttribute('src', basepath+'/check0.png');
		 c.appendChild(img);
		s.appendChild(c);
		 t = document.createElement('div');
		 t.setAttribute('onclick', 'doSearch("'+site[0]+'");this.lastChild.data="Searching...";');
		 t.setAttribute('title', 'Search '+site[0]+' now');
		 t.appendChild(document.createTextNode(site[0]));
		s.appendChild(t);
		search.appendChild(s);
	}
	popup.appendChild(search);
	
	toolbar = document.createElement('div');
	toolbar.setAttribute('style', 'position:fixed; bottom:-5px; right:14px; z-index:100;');
	toolbar.setAttribute('onmouseover', 'showSearchMenu()');
	img = document.createElement('img');
	img.setAttribute('src', basepath+'/searchnow.png');
	img.setAttribute('onclick', 'searchNow()');
	img.setAttribute('title', 'Search all (or all marked) sites now!');
	img.setAttribute('style', 'cursor:pointer;background:white;border:1px outset gray;padding:1px; margin-right:3px;');
	toolbar.appendChild(img);
	if(numfiles > 0) {
	  img = document.createElement('img');
	  img.setAttribute('src', basepath+'/edit.png');
	  img.setAttribute('onclick', 'editFile()');
	  img.setAttribute('title', 'Open current file externally');
	  img.setAttribute('style', 'cursor:pointer;background:white;border:1px outset gray;padding:1px;');
	  toolbar.appendChild(img);
	  img = document.createElement('img');
	  img.setAttribute('src', basepath+'/trash.png');
	  img.setAttribute('onclick', 'trashFile()');
	  img.setAttribute('title', 'Move current file to trash');
	  img.setAttribute('style', 'cursor:pointer;background:white;border:1px outset gray;padding:1px;');
	  toolbar.appendChild(img);
	}
	popup.appendChild(toolbar);
	
	ref = document.getElementById('current_box');
	ref.insertBefore(popup, ref.lastChild);
}
function mustHide(site) {
	hides = hideDomains.split(" ");
	for(j=0; j<hides.length; j++) {
		if(site.substr(site.length-4,4) == hides[j] ||
		   site.substr(site.length-3,3) == hides[j] ||
		   site.substr(site.length-2,2) == hides[j] ) {
		   return true;
		}
	}
	return false;
}
function toggleAutoSearch(sitename) {
	img = document.getElementById("conTEXT_autosearch_"+sitename).lastChild;
	if(img.src.substr(img.src.length-5) == "0.png") {
		img.src = basepath+"/check1.png";
		searchSites = searchSites.replace(sitename+":False",sitename+":True");
	} else {
		img.src = basepath+"/check0.png";
		searchSites = searchSites.replace(sitename+":True",sitename+":False");
	}
}
function toggleAll() {
	notAllSelected = /False/.test(searchSites);
	sites = searchSites.split(" ");
	for(i=0; i<sites.length; i++) {
		site = sites[i].split(":");
		sitename = site[0];
		if(notAllSelected) {
			try{ img = document.getElementById("conTEXT_autosearch_"+sitename).lastChild;
				 img.src = basepath+"/check1.png"; } catch(e){ }
			searchSites = searchSites.replace(sitename+":False",sitename+":True");
		} else {
			try{ img = document.getElementById("conTEXT_autosearch_"+sitename).lastChild;
			     img.src = basepath+"/check0.png"; } catch(e){ }
			searchSites = searchSites.replace(sitename+":True",sitename+":False");
		}
	}
}
function doSearch(sitename) {
	searchSite = sitename;
	anim = setTimeout("animateIcon()",500);
}
function searchNow() {
	someSiteSelected = /True/.test(searchSites);
	if(!someSiteSelected) {
		toggleAll();
		searchnow = "SEARCH_ALL_TEMPORARY";
	} else {
		searchnow = "SEARCH_MARKED";
	}
	removeSearchMenu();
}
function openURL(url) {
	clickedURL = url;
}
function editFile() {
	file2edit = originalfilenames[curindex];
	removeSearchMenu();
}
function trashFile() {
	file2trash = originalfilenames[curindex];
	if(numfiles==1)
		undoInjection();
	else
		removeSearchMenu();
}
function getCommands() {
	var s = searchSite;
	var u = clickedURL;
	var e = file2edit;
	var t = file2trash;
	var n = searchnow;
	searchnow = "";
	searchSite = "";
	clickedURL = "";
	file2edit = "";
	file2trash = "";
	return n+'|'+t+'|'+e+'|'+u+'|'+s+'|'+searchSites;
}
function searchSuccess(sitename) {
	var ref = document.getElementById('conTEXT_search_'+sitename);
	if(ref) ref.lastChild.lastChild.data = "...Found!";
	showFileWithName(sitename+".html");
	info(numfiles);
}
function searchFailure(sitename) {
	var ref = document.getElementById('conTEXT_search_'+sitename);
	if(ref) ref.lastChild.lastChild.data = "...Not found!";
	info(numfiles);
}
function searchError(sitename, msg) {
	var ref = document.getElementById('conTEXT_search_'+sitename);
	if(ref) ref.lastChild.lastChild.data = "...Error: " + msg;
	info(numfiles);
}
function removeSearchMenu(delay) {
	var ref = document.getElementById('conTEXT_search');
	if(ref) ref.parentNode.removeChild(ref);
}
function toggleSearchMenu() {
	var ref = document.getElementById('conTEXT_search');
	if(ref)
		ref.parentNode.removeChild(ref);
	else
		showSearchMenu();
}
function removeInfo() {
	var ref = document.getElementById('conTEXT_info');
	if(ref) ref.parentNode.removeChild(ref);
}
function undoInjection() {
	var ref = document.getElementById('conTEXT_info');
	if(ref) ref.parentNode.removeChild(ref);
	var ref = document.getElementById('conTEXT_search');
	if(ref) ref.parentNode.removeChild(ref);
	var ref = document.getElementById('conTEXT_box');
	if(ref) ref.parentNode.removeChild(ref);
}
