# -*- coding: utf-8 -*-

import sys
import logging
import time
import os
import urllib
import new
from threading import Thread,Lock,currentThread
from qt import *

from Observable import Observer
from amarok import DcopAmarokFailed

from conTEXToptions import conTEXToptions

logger = logging.getLogger("PyQt UI")
amarok = None
config = None
app = None

# async operation!!!
class AsyncOperation(QTimer):
	lock = Lock()
	def __init__(self,parent,time,func_call,*args):
		"""time is in seconds or fractions thereof"""
		self.lock.acquire()
		qApp.lock()
		try:
			QTimer.__init__(self,parent)
			self.func_call = func_call
			self.args = args
			logger.debug("Preparing %s in thread %s",self.func_call.__name__,currentThread())
			QObject.connect(self,SIGNAL("timeout()"),self.on_timeout)
			self.start(int(time*1000),True)
		finally:
			qApp.unlock()
			self.lock.release()
	
	def on_timeout(self):
		logger.debug("Running %s in thread %s",self.func_call.__name__,currentThread())
		args = self.args
		try: self.func_call(*args)
		except: logger.exception("Operation threw an exception")

class SyncOperation(AsyncOperation):
	def __init__(self,parent,func_call,*args):
		AsyncOperation.__init__(self,parent,0,func_call,*args)
# end async operation



def w(object,name): return object.child(name,None,True)

class OconTEXToptions(conTEXToptions):
	fully_initialized = False
	
	def __init__(self,parent):
		conTEXToptions.__init__(self,parent,name="Preferences window",fl=Qt.WDestructiveClose)
		
		w(self,"maxBoxHeight").setValue(int(config["maxBoxHeight"]))
		w(self,"expanded").setChecked(config["expanded"])
		w(self,"configPolling").setChecked(config["configPolling"])
		w(self,"saveOnlineReviews").setChecked(config["saveOnlineReviews"])
		w(self,"hideDotCom").setChecked(config["hideDotCom"])
		w(self,"hideDotCoUk").setChecked(config["hideDotCoUk"])
		w(self,"hideDotDe").setChecked(config["hideDotDe"])
		w(self,"hideDotNet").setChecked(config["hideDotNet"])
		w(self,"externalBrowser").setChecked(config["externalBrowser"])
				
		#combobox = w(self,"playlistComboBox")
		#def refill(self): # fixme esto debe bloquear las señales del combobox y proceder a hacer el refil, para posteriormente volver a tomar el valor que estaba seleccionado originalmente, SI ES QUE existe, y si no, ninguno.
			#self.clear()
			#pnames = ["The entire collection"] + amarok.smartPlaylistCollection.keys()
			#for pname in pnames: self.insertItem(tounicode(pname))
		#combobox.refill = new.instancemethod( refill, combobox, QComboBox )
		
		#combobox.refill()
		
		#if config["source_playlist"] is None:
			#combobox.setCurrentText("The entire collection")
		#else:
			#combobox.setCurrentText(config["source_playlist"])
		
#		QTimer.singleShot(500,self.updateStatus)
# 		timer = QTimer(self)
# 		QObject.connect(timer,SIGNAL("timeout()"),self.updateStatus)
# 		timer.start(5000)
		
		self.fully_initialized = True
	
	def configChangedByUser(self):
		if not self.fully_initialized: return
		logger.debug("Configuration changed by user")
		
		config["maxBoxHeight"] = w(self,"maxBoxHeight").value()
		config["expanded"] = w(self,"expanded").isChecked()
		config["configPolling"] = w(self,"configPolling").isChecked()
		config["saveOnlineReviews"] = w(self,"saveOnlineReviews").isChecked()
		config["hideDotCom"] = w(self,"hideDotCom").isChecked()
		config["hideDotCoUk"] = w(self,"hideDotCoUk").isChecked()
		config["hideDotDe"] = w(self,"hideDotDe").isChecked()
		config["hideDotNet"] = w(self,"hideDotNet").isChecked()
		config["externalBrowser"] = w(self,"externalBrowser").isChecked()
				
		#combobox = w(self,"playlistComboBox")
		
		#if combobox.currentItem() == 0:
			#config["source_playlist"] = None
		#else:
			#config["source_playlist"] = str(combobox.currentText())
		
		config.notifyChanged()
		logger.debug("New configuration: %s",config)
	
	
	def updateStatus(self):
		return
		#try:
			#current_song = analysisProcess.getNextSong()
			#app.processEvents()
			#pqueue_count = analysisProcess.getPriorityQueueLength()
			#app.processEvents()
			#total = amarok.collection.totalTracks()
			#app.processEvents()
			#left = amarok.collection.countUnanalyzedSongs()
			
			#if total == 0:
				#progress = 1.0
			#else:
				#progress = ( float(total) - float(left) ) / float(total)
			
			#logger.debug("Analysis process report: total: %s, left: %s",total,left)
			
			#if current_song:
				#w(self,"songCurrentlyAnalyzing").setText(tounicode("Analyzing %s"%current_song))
				#string = "%s of %s songs (%.1f%%) pending analysis"%(left,total,100-progress*100)
			#else:
				#if total == 0:
					#w(self,"overallProgressGroupBox").hide()
					#w(self,"songCurrentlyAnalyzing").setText(tounicode("No tracks in your collection.  Please rebuild your collection."))
				#else:
					#w(self,"overallProgressGroupBox").show()
					#w(self,"songCurrentlyAnalyzing").setText(tounicode("Idle.  All tracks have been analyzed."))
				#string = "%s tracks analyzed"%(total)
			#if pqueue_count:
				#if pqueue_count != 1: s = "s"
				#else: s = ""
				#w(self,"priorityQueueLength").setText(tounicode("%s track%s in the analysis priority queue"%(pqueue_count,s)))
			#else:
				#w(self,"priorityQueueLength").setText(tounicode("No tracks in the analysis priority queue"))
			
			#w(self,"analysisProgress").setProgress(int(progress*1000))
			#w(self,"analysisProgressText").setText(tounicode(string))
		#except DcopAmarokFailed,e:
			#logger.debug("amaroK is unexpectedly gone")


# my own qt app

class EventProcessor(Observer):
	
	def __init__(self,parent):
		Observer.__init__(self)
		self.parent = parent
		self.observe(amarok)
				
	def processEvent(self,object,eventName,*args):
		logger.debug( "Processing %s"%eventName)
		
		if eventName == "configure":
			self.parent.show_configuration()
			
		#if eventName == "customMenuClicked":
			#line = args[0]
			#logger.debug("Arguments: %s",args)
			#s = "Smart DJ Find tracks similar to selection..."
			
			#def getfilenames(prefix,string):
				#fnames = string[len(prefix)+1:]
				#fnames = [ urllib.url2pathname(fname)[7:] for fname in fnames.split(" ") ]
				#return fnames
			
			#if line[:len(s)] == s:
				#self.parent.search(getfilenames(s,line))
									
class UIApp(QApplication):
	def __init__(self):
		QApplication.__init__(self,sys.argv)
		self.eventProcessor = EventProcessor(self)
		self.mainWindow = QMainWindow()
		self.setMainWidget(self.mainWindow)
	
	#def search(self,files):
		#for file in files:
			#SyncOperation(self,self._search_sync,file)
	
	#def _search_sync(self,file):
		#search_window = OSearchWindow(self.mainWindow)
		#try:
			#title = None
			#message = None
			#search_window.show()
			#search_window.search(file)
		
		#except UnAnalyzable,e:
			#search_window.reject()
			#title = "Analysis on the selected track failed"
			#message = tounicode("The track %s could not be analyzed, probably because its compression format was not understood by songanalysis."%file)
			
		#except DcopAmarokFailed,e:
			#logger.debug("amaroK has gone unexpectedly",exc_info=True)
			#search_window.reject()
			#return
			
		#if title and message:
			#m = QMessageBox(title,message,QMessageBox.Information,QMessageBox.Ok,
			#QMessageBox.NoButton,QMessageBox.NoButton,self.mainWindow,None,True)
			#m.setTextFormat(Qt.RichText)
			#m.show()
	
	def _update_config_window_sync(self):
		existing_child = self.mainWindow.child("Preferences window",None,True)
		if existing_child:
			existing_child.updateStatus()
	
	def update_config_window(self):
		SyncOperation(self,self._update_config_window_sync)
	
	def show_configuration(self):
		SyncOperation(self,self._show_configuration_sync)
			
	def _show_configuration_sync(self):
		existing_child = self.mainWindow.child("Preferences window",None,True)
		if existing_child:
			existing_child.raiseW()
		else:
			OconTEXToptions(self.mainWindow).show()


def _run_ui_loop():
	global app
	try:
		logger.debug("Running ui loop in thread: %s",currentThread())
		app = UIApp()
		app.exec_loop()
	except:
		logger.exception("Something went wrong in the UI loop thread")


#------------ public implementation starts ----------------------

#custom_menu_items = ["Find tracks similar to selection...","Edit tempo of selected tracks...","Analyze selected tracks now","Set up Auto DJ mode..."]

def initialize(amaroKProxy,configObject):
	global amarok
	global config
	logger.debug("Initializing UI")
	amarok = amaroKProxy
	config = configObject
	t = Thread(target=_run_ui_loop)
	t.setName("UI thread")
	t.setDaemon(True)
	t.start()
#	for a in custom_menu_items:
#		amarok.script.addCustomMenuItem("Smart DJ",a)

def end():
	logger.debug("Disabling UI")
#	for a in custom_menu_items:
#		try: amarok.script.removeCustomMenuItem("Smart DJ",a)
#		except DcopAmarokFailed: pass

#def search(start_files):
	#""" Receive a Python list of file paths (NOT URLs)"""
	#while app is None: time.sleep(.3)
	#app.search(start_files)

def show_configuration():
	while app is None: time.sleep(.3)
	app.show_configuration()

